Name:           budgie-extras
Version:        1.7.0
Release:        1%{?dist}
Summary:        Additional enhancements for the Budgie user experience

License:        GPL-3.0-or-later
Group:          System/GUI/Other
URL:            https://github.com/UbuntuBudgie/%{name}
Source0:        %{url}/releases/download/v%{version}/budgie-extras-%{version}.tar.xz
Source1:        %{url}/releases/download/v%{version}/budgie-extras-%{version}.tar.xz.asc
Source2:        budgie-extras.keyring
# Here we have issue with hardcoded patch (https://github.com/UbuntuBudgie/budgie-extras/issues/426)
Patch0:         https://raw.githubusercontent.com/terrapkg/packages/f38/anda/desktops/budgie/budgie-extras/0001-fix-weathershow-desktop-widget-icon-path.patch

BuildRequires:  rpm_macro(fdupes)
BuildRequires:  cmake
BuildRequires:  meson
BuildRequires:  vala
BuildRequires:  intltool
BuildRequires:  gettext
BuildRequires:  gnupg2

BuildRequires:  pkgconfig(budgie-1.0)
BuildRequires:  pkgconfig(gee-0.8)
BuildRequires:  pkgconfig(gnome-settings-daemon)
BuildRequires:  pkgconfig(json-glib-1.0)
BuildRequires:  pkgconfig(keybinder-3.0)
BuildRequires:  pkgconfig(libgnome-menu-3.0)
BuildRequires:  pkgconfig(libnm)
BuildRequires:  pkgconfig(libnma)
BuildRequires:  pkgconfig(libnotify)
BuildRequires:  pkgconfig(libsoup-3.0)
BuildRequires:  pkgconfig(libwnck-3.0)

BuildRequires:  pkgconfig(appstream)
BuildRequires:  pkgconfig(granite)
BuildRequires:  pkgconfig(libhandy-1)
BuildRequires:  pkgconfig(zeitgeist-2.0)

# Looks like it better to be installed (https://github.com/UbuntuBudgie/budgie-extras/issues/233)
Requires:       xinput

Recommends:     budgie-app-launcher-applet
Recommends:     budgie-brightness-controller-applet
Recommends:     budgie-clockworks-applet
Recommends:     budgie-countdown-applet
Recommends:     budgie-dropby-applet
Recommends:     budgie-fuzzyclock-applet
Recommends:     budgie-hotcorners-applet
Recommends:     budgie-kangaroo-applet
Recommends:     budgie-keyboard-autoswitch-applet
Recommends:     budgie-network-manager-applet
Recommends:     budgie-previews
Recommends:     budgie-quickchar
Recommends:     budgie-quicknote-applet
Recommends:     budgie-recentlyused-applet
Recommends:     budgie-rotation-lock-applet
Recommends:     budgie-showtime-applet
Recommends:     budgie-takeabreak-applet
Recommends:     budgie-visualspace-applet
Recommends:     budgie-wallstreet
Recommends:     budgie-weathershow-applet
Recommends:     budgie-window-shuffler
Recommends:     budgie-workspace-stopwatch-applet
Recommends:     budgie-workspace-wallpaper-applet

%description
Additional Budgie Desktop enhancements for user experience

%package -n budgie-app-launcher-applet
Requires:       budgie-extras-common
Summary:        App Launcher applet
Group:          System/GUI/Other

%description -n budgie-app-launcher-applet
 The app-launcher applet allows the ability to add favorite apps to the
panel as well as finding and launching applications. The list of
applications listed can be easily configured to be visible or hidden.

%package -n budgie-applications-menu-applet
Requires:       budgie-extras-common
Summary:        Stylish Applications Menu applet
Group:          System/GUI/Other

%description -n budgie-applications-menu-applet
 The application-menu is a stylish panel applet that displays applications
in different views - grid and list. Weblinks typed into the search bar
can be opened in your default browser. Applications that have additional
desktop options show via a right-click menu. Applications with associated
actions show those actions are additional searchable entries.

%package -n budgie-brightness-controller-applet
Requires:       budgie-extras-common
Summary:        Brightness controller applet
Group:          System/GUI/Other

%description -n budgie-brightness-controller-applet
 Applet to control the brightness of the screen.

%package -n budgie-clockworks-applet
Requires:       budgie-extras-common
Summary:        Clockworks applet
Group:          System/GUI/Other

%description -n budgie-clockworks-applet
 The Clockworks applet displays the current time across multiple
time zones.


%package -n budgie-countdown-applet
Requires:       budgie-extras-common
Summary:        Countdown applet
Group:          System/GUI/Other

%description -n budgie-countdown-applet
 The Countdown applet provides the user the ability to start an
action when the countdown reaches 0 seconds. Actions include flashing
an icon in the panel, opening a notification window, sounding a
bell or running a custom command.

%package -n budgie-dropby-applet
Requires:       budgie-extras-common
Summary:        DropBy applet
Group:          System/GUI/Other

%description -n budgie-dropby-applet
 The DropBy applet pops up in the panel when connecting a usb device.
The applet subsequently offers the option(s) to mount, unmount/eject
and in case of a flash drive, to make a local copy of the drive's
content. The info shows the free space on the volume.

%package        common
Requires:       budgie-desktop
BuildArch:      noarch
Summary:        Shared component of budgie-extras applets
Group:          System/GUI/Other

%description    common
 The shared component provides for capabilities that are utilised between
budgie-extra applets.

%package        daemon
Requires:       budgie-extras-common
Summary:        Extras daemon for budgie-extras capabilities
Group:          System/GUI/Other

%description   daemon
 Budgie-Extras-Daemon provides both global keybinding and D-Bus functionality
for various extras applets and applications.

%package -n budgie-fuzzyclock-applet
Requires:       budgie-extras-common
Summary:        Fuzzyclock Applet
Group:          System/GUI/Other

%description -n budgie-fuzzyclock-applet
 Show the time in a fuzzy way.
Displays the time in a 'spoken' format such as five past six.

%package -n budgie-hotcorners-applet
Requires:       budgie-extras-common
Recommends:     budgie-window-shuffler
Summary:        Hotcorners applet
Group:          System/GUI/Other

%description -n budgie-hotcorners-applet
 The hotcorners applet allow user defined commands to be executed
when the mouse cursor is pushed into a corner of the main desktop.

%package -n budgie-kangaroo-applet
Requires:       budgie-extras-common
Summary:        Kangaroo applet
Group:          System/GUI/Other

%description -n budgie-kangaroo-applet
 Applet to allow quick file-browsing.
The kangaroo applet allows for quick & easy browsing, across
(possibly) many directory layers, without having to do a single mouse
click.

%package -n budgie-keyboard-autoswitch-applet
Requires:       budgie-extras-common
Summary:        Keyboard autoswitch applet
Group:          System/GUI/Other

%description -n budgie-keyboard-autoswitch-applet
 Applet adding the ability to set a different keyboard layout per application.
The Keyboard Auto Switcher applet provides the user the ability to set
a different keyboard layout per application. Exceptions to the default
layout can be set by simply choosing a different layout using the
Keyboard Layout applet.

%package -n budgie-network-manager-applet
Requires:       budgie-extras-common
Summary:        Network manager applet
Group:          System/GUI/Other

%description -n budgie-network-manager-applet
 Network Manager Applet for the budgie-desktop.
This package installs an Network connectivity applet for the
budgie-desktop.

%package -n budgie-previews
Requires:       budgie-extras-common
Requires:       budgie-extras-daemon
Requires:       xinput
Summary:        Previews applet
Group:          System/GUI/Other

%description -n budgie-previews
 Provides window previews capabilities for the Budgie Desktop.
That shows an overview of windows in an expose like way.

%package -n budgie-quickchar
Requires:       budgie-extras-common
Requires:       budgie-extras-daemon
Summary:        Quickchar applet
Group:          System/GUI/Other

%description -n budgie-quickchar
 Quickly find and choose the equivalent locale character for an ascii
character.

%package -n budgie-quicknote-applet
Requires:       budgie-extras-common
Summary:        Quicknote applet
Group:          System/GUI/Other

%description -n budgie-quicknote-applet
 Applet providing simple notes capability for the Budgie Desktop.
The quicknote applet allows a user to record a text based note.
The applet supports multiple undo and redo capabilities.

%package -n budgie-recentlyused-applet
Requires:       budgie-extras-common
Summary:        Recently Used applet
Group:          System/GUI/Other

%description -n budgie-recentlyused-applet
 Applet displays files recently accessed for the Budgie Desktop.
The recentlyused applet displays the users files that have been opened
or created within a configurable period of time.

%package -n budgie-rotation-lock-applet
Requires:       budgie-extras-common
Summary:        Rotationlock applet
Group:          System/GUI/Other

%description -n budgie-rotation-lock-applet
 The Rotation Lock applet provides the user an easy way to lock or
unlock the screen rotation.

%package -n budgie-showtime-applet
Requires:       budgie-extras-common
Summary:        Showtime applet
Group:          System/GUI/Other

%description -n budgie-showtime-applet
 The ShowTime applet is a digital desktop clock, showing time and/or
date. Text color of both the displayed time and date can be set
separately from the applet's menu

%package -n budgie-takeabreak-applet
Requires:       budgie-extras-common
Summary:        Takeabreak applet
Group:          System/GUI/Other

%description -n budgie-takeabreak-applet
 Applet to prompt when to take-a-break for a set period of time.
The take-a-break applet monitors how long a desktop is being used
and at a configurable time period suggests when to take a break
from working.

%package -n budgie-visualspace-applet
Requires:       budgie-extras-common
Summary:        Visualspace applet
Group:          System/GUI/Other

%description -n budgie-visualspace-applet
 Show and manage windows in workspaces for the Budgie Desktop.
The visualspace applet shows as a stylish compact workspace on the budgie
panel. Choosing windows in the applet popup moves to the workspace
where the window is located and gives it focus.
The number of Workspace can also be changed though the applet popup.

%package -n budgie-wallstreet
Requires:       budgie-extras-common
Summary:        Wallstreet miniapp
Group:          System/GUI/Other

%description -n budgie-wallstreet
 Change wallpaper from a folder on a schedule.
Wallstreet allows for a directory of pictures to be shown on
a schedule.

%package -n budgie-weathershow-applet
Requires:       budgie-extras-common
Summary:        Weathershow applet
Group:          System/GUI/Other

%description -n budgie-weathershow-applet
 Applet to display the weather and forecast.
The weathershow applet displays daily and three hourly weather
forecasts on both the desktop and a Popover.

%package -n budgie-window-shuffler
Requires:       budgie-extras-common
Requires:       budgie-extras-daemon
Summary:        Window shuffler applet
Group:          System/GUI/Other

%description -n budgie-window-shuffler
 Keyboard and GUI friendly window-tiling capability.
The window shuffler is an easy to use windows tiling capability
driven primarily through the keyboard to place and move window in
a grid format.

%package -n budgie-workspace-stopwatch-applet
Requires:       budgie-extras-common
Summary:        Workspace stopwatch applet
Group:          System/GUI/Other

%description -n budgie-workspace-stopwatch-applet
 Workspace usage tracker for the budgie desktop.
Workspace Stopwatch Applet keeps track of usage per workspace,
i.e. to find out how much minutes/hours were actually spent on a job.
Workspaces can be freely named, custom names and all data are remembered.

%package -n budgie-workspace-wallpaper-applet
Requires:       budgie-extras-common
Requires:       budgie-extras-daemon
Summary:        Workspace Wallpaper applet
Group:          System/GUI/Other

%description -n budgie-workspace-wallpaper-applet
 Applet providing per workspace wallpaper.
The workspace wallpaper applet shows a different wallpaper on each of
the workspaces. Usage is simple: add the applet to the panel and set
wallpapers on each of the workspaces in the way you are used to.
The applet will remember what wallpaper was set on each of the
workspaces.

%prep
# Lets verify source file
%{gpgverify} --keyring='%{SOURCE2}' --signature='%{SOURCE1}' --data='%{SOURCE0}'
%autosetup -p1

%build
%meson
%meson_build

%install
%meson_install
%find_lang %{name}

# Remove absolute symlink and replace with relative symlink
rm -f %{buildroot}%{_bindir}/quickchar
%fdupes %_libdir/budgie-desktop/plugins/budgie-weathershow/weather_icons

%post
%{__ln_s} -fv %{_bindir}/quickchar %{_libdir}/quickchar/quickchar

%files -f %{name}.lang
%license LICENSE
%doc README.md

%files common
%{_datadir}/glib-2.0/schemas/20_budgie-extras.gschema.override

%files daemon
%config %{_sysconfdir}/xdg/autostart/budgie-extras-daemon.desktop
%{_bindir}/budgie-extras-daemon
%{_libdir}/budgie-extras-daemon/invoke.py
%{_datadir}/budgie-desktop/layouts/*.layout
%{_datadir}/budgie-extras-daemon
%{_mandir}/man1/budgie-extras-daemon.1.gz

%files -n budgie-app-launcher-applet
%{_datadir}/pixmaps/budgie-app-launcher*.svg
%{_libdir}/budgie-desktop/plugins/budgie-app-launcher

%files -n budgie-applications-menu-applet
%{_libdir}/budgie-desktop/plugins/applications-menu
%{_datadir}/glib-2.0/schemas/org.ubuntubudgie.plugins.budgie-appmenu.gschema.xml

%files -n budgie-brightness-controller-applet
%{_libdir}/budgie-desktop/plugins/budgie-brightness-controller
%{_datadir}/pixmaps/budgie-brightness-controller-1-symbolic.svg

%files -n budgie-clockworks-applet
%{_libdir}/budgie-desktop/plugins/budgie-clockworks
%{_datadir}/glib-2.0/schemas/*budgie-clockworks*.xml
%{_datadir}/pixmaps/budgie-clockworks*.svg

%files -n budgie-countdown-applet
%{_libdir}/budgie-desktop/plugins/budgie-countdown
%{_datadir}/glib-2.0/schemas/org.ubuntubudgie.plugins.budgie-countdown.gschema.xml
%{_datadir}/pixmaps/budgie-countdown-symbolic.svg
%{_datadir}/pixmaps/cr_*.png

%files -n budgie-dropby-applet
%{_libdir}/budgie-desktop/plugins/budgie-dropby
%{_datadir}/glib-2.0/schemas/org.ubuntubudgie.plugins.budgie-dropby.gschema.xml
%{_datadir}/pixmaps/budgie-dropby*.svg

%files -n budgie-fuzzyclock-applet
%{_libdir}/budgie-desktop/plugins/budgie-fuzzyclock

%files -n budgie-hotcorners-applet
%{_libdir}/budgie-desktop/plugins/budgie-hotcorners
%config %{_sysconfdir}/xdg/autostart/org.ubuntubudgie.budgie-extras.HotCorners-autostart.desktop
%{_datadir}/glib-2.0/schemas/org.ubuntubudgie.budgie-extras.HotCorners.gschema.xml
%{_datadir}/applications/org.ubuntubudgie.budgie-extras.HotCorners.desktop
%{_datadir}/budgie-hotcorners
/usr/libexec/budgie-hotcorners/

%{_datadir}/pixmaps/budgie-hotcorners-symbolic.svg
%{_datadir}/pixmaps/budgie-hotcgui-*.svg
%{_datadir}/icons/hicolor/scalable/apps/org.ubuntubudgie.budgie-extras.hotcorners.svg

%files -n budgie-kangaroo-applet
%{_libdir}/budgie-desktop/plugins/budgie-kangaroo
%{_datadir}/pixmaps/budgie-foldertrack-symbolic.svg

%files -n budgie-keyboard-autoswitch-applet
%{_libdir}/budgie-desktop/plugins/budgie-keyboard-autoswitch
%{_datadir}/pixmaps/budgie-keyboard-autoswitch-symbolic.svg

%files -n budgie-network-manager-applet
%{_libdir}/budgie-desktop/plugins/budgie-network-manager

%files -n budgie-quickchar
%config %{_sysconfdir}/xdg/autostart/quickchar-autostart.desktop
%ghost %{_bindir}/quickchar
%{_libdir}/quickchar
%{_datadir}/applications/org.ubuntubudgie.quickchar.desktop
%{_datadir}/glib-2.0/schemas/org.ubuntubudgie.quickchar.gschema.xml
%{_datadir}/quickchar/chardata
%{_datadir}/icons/hicolor/scalable/apps/org.ubuntubudgie.quickchar.svg
%{_mandir}/man1/quickchar.1.gz
%{_datadir}/metainfo/org.ubuntubudgie.quickchar.metainfo.xml

%files -n budgie-quicknote-applet
%{_libdir}/budgie-desktop/plugins/budgie-quicknote
%{_datadir}/glib-2.0/schemas/org.ubuntubudgie.plugins.quicknote.gschema.xml
%{_datadir}/pixmaps/budgie-quicknote-symbolic.svg

%files -n budgie-recentlyused-applet
%{_libdir}/budgie-desktop/plugins/budgie-recentlyused
%{_datadir}/glib-2.0/schemas/org.ubuntubudgie.plugins.budgie-recentlyused.gschema.xml

%files -n budgie-rotation-lock-applet
%{_libdir}/budgie-desktop/plugins/budgie-rotation-lock
%{_datadir}/pixmaps/budgie-rotation-*.svg

%files -n budgie-showtime-applet
%{_libdir}/budgie-desktop/plugins/budgie-showtime
%{_datadir}/glib-2.0/schemas/org.ubuntubudgie.plugins.budgie-showtime.gschema.xml
%{_datadir}/pixmaps/showtimenew-symbolic.svg

%files -n budgie-takeabreak-applet
%{_libdir}/budgie-desktop/plugins/budgie-takeabreak
%{_datadir}/glib-2.0/schemas/org.ubuntubudgie.plugins.takeabreak.gschema.xml
%{_datadir}/pixmaps/takeabreak*.svg

%files -n budgie-visualspace-applet
%config %{_sysconfdir}/xdg/autostart/visualspace-autostart.desktop
%{_libdir}/budgie-desktop/plugins/budgie-visualspace
%{_datadir}/glib-2.0/schemas/org.ubuntubudgie.plugins.budgie-visualspace.gschema.xml
%{_datadir}/pixmaps/visualspace-symbolic.svg

%files -n budgie-wallstreet
%config %{_sysconfdir}/xdg/autostart/wallstreet-autostart.desktop
%{_libdir}/budgie-wallstreet/wallstreet*
%{_datadir}/applications/org.ubuntubudgie.wallstreetcontrol.desktop
%{_datadir}/glib-2.0/schemas/org.ubuntubudgie.budgie-wallstreet.gschema.xml
%{_datadir}/icons/hicolor/scalable/apps/org.ubuntubudgie.wallstreet-control.svg
%{_datadir}/metainfo/org.ubuntubudgie.wallstreetcontrol.metainfo.xml

%files -n budgie-weathershow-applet
%{_libdir}/budgie-desktop/plugins/budgie-weathershow
%{_datadir}/glib-2.0/schemas/org.ubuntubudgie.plugins.weathershow.gschema.xml
%{_datadir}/pixmaps/budgie-wticon-symbolic.svg

%files -n budgie-window-shuffler
%config %{_sysconfdir}/xdg/autostart/layoutspopup-autostart.desktop
%config %{_sysconfdir}/xdg/autostart/dragsnap-autostart.desktop
%config %{_sysconfdir}/xdg/autostart/shuffler*.desktop
%{_libdir}/budgie-window-shuffler
%{_datadir}/applications/org.ubuntubudgie.shufflercontrol.desktop
%{_datadir}/icons/hicolor/scalable/apps/org.ubuntubudgie.shuffler-control.svg
%{_datadir}/glib-2.0/schemas/org.ubuntubudgie.windowshuffler.gschema.xml
%{_datadir}/glib-2.0/schemas/org.ubuntubudgie.plugins.budgie-shufflerapplet.gschema.xml
%{_datadir}/pixmaps/shuffler-*.svg
%{_datadir}/pixmaps/shufflerapplet-*.svg
%{_datadir}/pixmaps/dragsnapimg*.svg
%{_libdir}/budgie-desktop/plugins/budgie-window-shuffler/ShufflerAPplet.plugin
%{_libdir}/budgie-desktop/plugins/budgie-window-shuffler/libshufflerapplet.so
%{_datadir}/metainfo/org.ubuntubudgie.shufflercontrol.metainfo.xml

%files -n budgie-workspace-stopwatch-applet
%{_libdir}/budgie-desktop/plugins/budgie-workspace-stopwatch
%{_datadir}/pixmaps/budgie-wstopwatch-symbolic.svg

%files -n budgie-previews
%config %{_sysconfdir}/xdg/autostart/previews-*.desktop
%{_libdir}/budgie-previews
%{_datadir}/applications/org.ubuntubudgie.previewscontrols.desktop
%{_datadir}/metainfo/org.ubuntubudgie.previewscontrols.metainfo.xml
%{_datadir}/glib-2.0/schemas/org.ubuntubudgie.budgie-wpreviews.gschema.xml
%{_datadir}/pixmaps/budgie_wpreviews_*.png
%{_datadir}/icons/hicolor/scalable/apps/org.ubuntubudgie.budgiewpreviews.svg

%files -n budgie-workspace-wallpaper-applet
%{_libdir}/budgie-desktop/plugins/budgie-wswitcher
%{_datadir}/glib-2.0/schemas/org.ubuntubudgie.plugins.budgie-wswitcher.gschema.xml
%{_datadir}/pixmaps/budgie-wsw-symbolic.svg

%changelog
* Sat Sep 02 2023 Kira Roubin <jplie@kiri.su> - 1.7.0-1
- Update to version 1.7.0
* Thu Jun 29 2023 Kira Roubin <jplie@kiri.su> - 1.6.0-2
- Add missing applets requirements

* Wed Jun 28 2023 Kira Roubin <jplie@kiri.su> - 1.6.0-1
- Initial packaging version 1.6.0
